import java.io.*;
import java.util.*;

public class sol_ma {
    private final InputReader reader;
    private final OutputWriter writer;

    public sol_ma(InputReader reader, OutputWriter writer) {
        this.reader = reader;
        this.writer = writer;
    }

    public static void main(String[] args) {
        InputReader reader = new InputReader(System.in);
        OutputWriter writer = new OutputWriter(System.out);
        new sol_ma(reader, writer).run();
        writer.writer.flush();
    }


    public void run() {
        int n = reader.nextInt();
        Map<Integer, Integer> X = new TreeMap<>(), Y = new TreeMap<>();
        Map<Long, Integer> XY = new TreeMap<>();
        for (int i = 0; i < n; i++) {
            int x = reader.nextInt();
            int y = reader.nextInt();
            long xy = (((long)(x + 1000 * 1000 * 1000)) << 32) | (y + 1000 * 1000 * 1000);
            int xv = (X.containsKey(x)) ? X.get(x) + 1 : 1;
            X.put(x, xv);
            int yv = (Y.containsKey(y)) ? Y.get(y) + 1 : 1;
            Y.put(y, yv);
            int xyv = XY.containsKey(xy) ? XY.get(xy) + 1 : 1;
            XY.put(xy, xyv);
        }
        long ans = 0;
        for (Map.Entry<Integer, Integer> e: X.entrySet()) {
            ans += ((long)e.getValue()) * (e.getValue() - 1) / 2;
        }
        for (Map.Entry<Integer, Integer> e: Y.entrySet()) {
            ans += ((long)e.getValue()) * (e.getValue() - 1) / 2;
        }
        for (Map.Entry<Long, Integer> e: XY.entrySet()) {
            ans -= ((long)e.getValue()) * (e.getValue() - 1) / 2;
        }
        writer.printf("%d\n", ans);
    }


    static class InputReader {
        public BufferedReader reader;
        public StringTokenizer tokenizer;

        public InputReader(InputStream stream) {
            reader = new BufferedReader(new InputStreamReader(stream), 32768);
            tokenizer = null;
        }

        public String next() {
            while (tokenizer == null || !tokenizer.hasMoreTokens()) {
                try {
                    tokenizer = new StringTokenizer(reader.readLine());
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            }
            return tokenizer.nextToken();
        }

        public int nextInt() {
            return Integer.parseInt(next());
        }

        public double nextDouble() {
            return Double.parseDouble(next());
        }

        public long nextLong() {
            return Long.parseLong(next());
        }
    }

    static class OutputWriter {
        public PrintWriter writer;

        OutputWriter(OutputStream stream) {
            writer = new PrintWriter(stream);
        }

        public void printf(String format, Object... args) {
            writer.print(String.format(Locale.ENGLISH, format, args));
        }
    }
}
