#include <iostream>
#include <fstream>
#include <vector>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <stdio.h>
#include <stack>
#include <string>
#include <memory.h>
#include <unordered_map>
#include <map>
#include <queue>

#define  y1 y1_fjgdhgiueh
using namespace std;

const int maxN = 8e5;

int h[maxN];
int t[4 * maxN];
pair<int, int> tree[4 * maxN];
vector < vector <pair <int, int> > >req;
int ans[maxN];
int mm[maxN];
int Llen[maxN];
int Rlen[maxN];
int inn[maxN];


pair <int, int> get_tree(int tl, int tr, int l, int r, int v){
	if (tl > tr || l > tr || tl > r)return make_pair(0, 0);
	if (tl >= l && tr <= r){
		return tree[v];
	}
	int m = (tl + tr) / 2;
	return max(get_tree(tl, m, l, r, 2 * v), get_tree(m + 1, tr, l, r, 2 * v + 1));
}

void update_tree(int tl, int tr, int id, int v, pair <int, int> val){
	if (tl > tr || id < tl || id > tr){
		return;
	}
	if (tl == tr){
		tree[v] = max(val, tree[v]);
		return;
	}
	int m = (tl + tr) / 2;
	update_tree(tl, m, id, 2 * v, val);
	update_tree(m + 1, tr, id, 2 * v + 1, val);
	tree[v] = max(tree[2 * v], tree[2 * v + 1]);
}


int get(int tl, int tr, int l, int r, int v){
	if (tl > tr || l > tr || tl > r)return 0;
	if (tl >= l && tr <= r){
		return t[v];
	}
	int m = (tl + tr) / 2;
	return max(get(tl, m, l, r, 2 * v), get(m + 1, tr, l, r, 2 * v + 1));
}

void update(int tl, int tr, int id, int v, int val){
	if (tl > tr || id < tl || id > tr){
		return;
	}
	if (tl == tr){
		t[v] = max(val, t[v]);
		return;
	}
	int m = (tl + tr) / 2;
	update(tl, m, id, 2 * v, val);
	update(m + 1, tr, id, 2 * v + 1, val);
	t[v] = max(t[2 * v], t[2 * v + 1]);
}

vector <pair <int, int> > pp;
unordered_map <int, int> mmap;


vector <int> tmp;
int s[maxN];
int main(void){

	int n, m;
	//ios_base::sync_with_stdio(0);
	cin >> n >> m;
	req.resize(n + 1);
	for (int i = 1; i <= n; i++){
		scanf("%d", &h[i]);
		tmp.push_back(h[i]);
	}
	for (int j = 1; j <= m; j++){
		int x, y;
		scanf("%d %d", &x, &y);
		pp.push_back(make_pair(x, y));
		req[x].push_back(make_pair(y, j));
		tmp.push_back(y);
	}
	sort(tmp.begin(), tmp.end());
	int cur = 0;
	for (int i = 0; i < (int)tmp.size(); i++){
		if (mmap[tmp[i]]){
			continue;
		}
		else{
			mmap[tmp[i]] = cur + 1;
			cur++;
		}
	}
	for (int i = 0; i < m; i++){
		pp[i].second = mmap[pp[i].second];
	}

	int best = 0;
	for (int i = 1; i <= n; i++){
		h[i] = mmap[h[i]];
		for (int j = 0; j < (int)req[i].size(); j++){
			req[i][j].first = mmap[req[i][j].first];
			ans[req[i][j].second] += get(1, maxN - 1, 1, req[i][j].first - 1, 1) + 1;
		}
		Llen[i] = get(1, maxN - 1, 1, h[i] - 1, 1) + 1;
		best = max(best, Llen[i]);
		update(1, maxN - 1, h[i], 1, Llen[i]);
	}
	memset(t, 0, (4 * maxN - 2) * sizeof(int));
		for (int i = n; i >= 1; i--){
		for (int j = 0; j < (int)req[i].size(); j++){
			ans[req[i][j].second] += get(1, maxN - 1, req[i][j].first + 1, maxN - 1, 1);
		}
		Rlen[i] = get(1, maxN - 1, h[i] + 1, maxN - 1, 1) + 1;
		update(1, maxN - 1, h[i], 1, Rlen[i]);
	}


	for (int i = 1; i <= n; i++){
		int sum = Rlen[i];
		if (sum == best){
			if (i >= 2){
				s[1]++;
				s[i]--;
			}
			if (i == 1){
				continue;
			}
			else{
				update_tree(1, maxN - 1, h[i - 1], 1, make_pair(Llen[i - 1], -i + 1));
			}
			continue;
		}
		pair <int, int> cur = get_tree(1, maxN - 1, 1, h[i] - 1, 1);
		if (cur.first + sum == best){
			s[-cur.second + 1]++;
			s[i]--;
		}
		if (i == 1){
			continue;
		}
		else{
			update_tree(1, maxN - 1, h[i - 1], 1, make_pair(Llen[i - 1], -i + 1));
		}
	}
	for (int i = 1; i <= n; i++){
		if (Llen[i] == best){
			s[i + 1]++;
			break;
		}
	}
	int sum = 0;
	for (int i = 1; i <= n; i++){
		inn[i] = inn[i - 1] + s[i];
	}
	for (int i = 1; i <= m; i++){
		int cur = max(ans[i], best - 1);
		if (inn[pp[i - 1].first]){
			cur = max(cur, best);
		}
		printf("%d\n", cur);
	}






	return 0;
}	