#include <iostream>
#include <fstream>
#include <set>
#include <map>
#include <string>
#include <vector>
#include <bitset>
#include <algorithm>
#include <cstring>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <queue>


typedef long long ll;
typedef long double ld;

using namespace std;
const int MAXN = 100010;
int ff[MAXN * 2];
int a[MAXN];
int n, m;

int gn;
int get(int x) {
	int ans = 0;
	for (; x >= 0; x &= x + 1, --x)
		ans = max(ans, ff[x]);
	return ans;
}

void upd(int x, int y) {
	for (; x < gn; x |= x + 1)
		ff[x] = max(ff[x], y);
}

vector<int> vv;

int solve() {
	gn = vv.size() + 4;
	memset(ff, 0, sizeof(ff[0]) * gn);
	int mx = 0;
	for (int i = 0; i < n; ++i) {
		int x = get(a[i] - 1);
		mx = max(mx, x + 1);
		upd(a[i], x + 1);
	}
	return mx;
}
int qx[MAXN];
int qy[MAXN];

int main() {
	cin >> n >> m;
	if (n >= MAXN || m >= MAXN)
		while (true);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		vv.push_back(a[i]);
	}
	for (int i = 0; i < m; ++i) {
		scanf("%d%d", qx + i, qy + i);
		vv.push_back(qy[i]);
	}
	sort(vv.begin(), vv.end());
	vv.resize(unique(vv.begin(), vv.end()) - vv.begin());
	for (int i = 0; i < n; ++i)
		a[i] = lower_bound(vv.begin(), vv.end(), a[i]) - vv.begin() + 1;
	for (int i = 0; i < m; ++i)
		qy[i] = lower_bound(vv.begin(), vv.end(), qy[i]) - vv.begin() + 1;

	for (int i = 0; i < m; ++i) {
		int x, y;
		x = qx[i], y = qy[i];
		--x;
		int tmp = a[x];
		a[x] = y;
		printf("%d\n", solve());
		a[x] = tmp;
	}
	return 0;
}


