#include <iostream>
#include <fstream>
#include <set>
#include <map>
#include <string>
#include <vector>
#include <bitset>
#include <algorithm>
#include <cstring>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <queue>

typedef long long ll;
typedef long double ld;

using namespace std;
const int INF = 1000000010;
const int MAXN = 500001;

int n, m;
int a[MAXN];
int go[MAXN];
int qx[MAXN];
int qy[MAXN];

vector<int> vv;

int solve() {
	fill(go, go + vv.size() + 2, 0);
	int ans = 0;
	for (int i = 0; i < n; ++i) {
		int mx = 0;
		for (int j = 0; j < a[i]; ++j)
			mx = max(mx, go[j]);
		++mx;
		ans = max(mx, ans);
		go[a[i]] = mx;
	}
	return ans;
}

int main() {
	scanf("%d%d", &n, &m);
	for (int i = 0; i < n; ++i)
		scanf("%d", a + i), vv.push_back(a[i]);
	for (int i = 0; i < m; ++i) {
		scanf("%d%d", qx + i, qy + i);
		vv.push_back(qy[i]);
	}
	sort(vv.begin(), vv.end());
	vv.resize(unique(vv.begin(), vv.end()) - vv.begin());
	for (int i = 0; i < n; ++i)
		a[i] = lower_bound(vv.begin(), vv.end(), a[i]) - vv.begin() + 1;
	for (int i = 0; i < m; ++i)
		qy[i] = lower_bound(vv.begin(), vv.end(), qy[i]) - vv.begin() + 1;
	for (int i = 0; i < m; ++i) {
		int x, y;
		x = qx[i];
		y = qy[i];
		--x;
		int tmp = a[x];
		a[x] = y;
		printf("%d\n", solve());
		a[x] = tmp;
	}
	
	return 0;
}


