#include "testlib.h"
#include <iostream>
#include <fstream>
#include <set>
#include <map>
#include <string>
#include <vector>
#include <bitset>
#include <algorithm>
#include <cstring>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <queue>


typedef long long ll;
typedef long double ld;

using namespace std;


int main(int argc, char **argv) {
	//Usage: nl, nr, ml, mr, max_h, seed
	assert(argc == 7);
	registerGen(argc, argv, 1);
	int nl = atoi(argv[1]);
	int nr = atoi(argv[2]);
	int ml = atoi(argv[3]);
	int mr = atoi(argv[4]);
	int max_h = atoi(argv[5]);
	int n = rnd.next(nl, nr);
	int m = rnd.next(ml, mr);
	cout << n << " " << m << "\n";
	for (int i = 0; i < n; ++i) {
		if (i != 0)
			cout << " ";
		cout << rnd.next(1, max_h);
	}
	cout << "\n";
	for (int i = 0; i < m; ++i) {
		cout << rnd.next(1, n) << " ";
		cout << rnd.next(1, max_h) << "\n";
	}
	return 0;
}


