#include <algorithm>
#include <cstdio>
#include <vector>

using namespace std;

int main() {
    int n, m;
    scanf("%d %d", &n, &m);
    
    vector<pair<int, int> > arr(n);
    for (int i = 0; i != n; ++i) {
        scanf("%d", &arr[i].first);
        arr[i].second = i;
    }
    
    sort(arr.begin(), arr.end());
    vector<int> ans(n);
    int curr = 1;
    
    for (int i = 0; i != n; ++i) {
        if (i && arr[i].first != arr[i - 1].first) {
            ++curr;
        }
        ans[arr[i].second] = curr;
    }
    
    for (int i = 0; i != n; ++i) {
        printf("%d\n", ans[i]);
    }
    
    return 0;
}