#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>

using namespace std;

const long double  mx = 1e9;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.setf(ios::fixed);
    cout.precision(4);
    int n, m;
    cin >> n >> m;
    vector < int > mx(n, 0);
    vector < int > my(m, 0);
    set < int > exist;
    set < pair <pair < int, int >, pair < int, int > > > q;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            int a;
            cin >> a;
            int ex = 1;
            if (exist.find(a) == exist.end()) {
                ex = 0;
            }
            exist.insert(a);
            q.insert({{a, ex}, {i, j}});
        }
    }
    vector < vector < int > > ans (n, vector < int > (m,0));
    int last_min = 0;
    for (auto p: q) {
        int mn;
        if (p.first.second == 0) {
            mn = max(mx[p.second.first], my[p.second.second]);
            mn++;
            last_min = mn;
        } else {
            mn = last_min;
        }

        mx[p.second.first] = mn;
        my[p.second.second] = mn;
        ans[p.second.first][p.second.second] = mn;
        last_min = mn;
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << ans[i][j] << " ";
        }
        cout << endl;
    }
    return 0;
}