#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

#define all(c) (c).begin(),(c).end()
#define sz(c) (int)(c).size()
#define pb push_back
#define mp make_pair
#define x first
#define y second
#define image(a) {sort(all(a)), a.resize(unique(all(a)) - a.begin());}
const int maxn = 500010;
set<int> a[2][maxn];
set<pair<int, int>> s[2];
void add(int k, int x, int y) {
  a[k][x].insert(y);
  a[k][y].insert(x);
}
void del(int k, int x, int y) {
  a[k][x].erase(y);
  a[k][y].erase(x);
}
vector<int> st;
pair<int, int> e1;
int col[maxn];
bool dfs(int v, int pr, int en) {
  st.pb(v);
  if (v == en) {
    for (int i = 0; i + 1 < sz(st); i++) {
      int x1 = st[i];
      int x2 = st[i + 1];
      if (x1 > x2) {
        swap(x1, x2);
      }
      if (col[x1] != col[x2] && s[1].find(mp(x1, x2)) != s[1].end()) {
        e1 = mp(x1, x2);
        return true;
      } 
    }
    assert(false);
  }
  for (int e : a[1][v]) if (e != pr) {
    if (dfs(e, v, en)) {
      return true;
    }
  }
  st.pop_back();
  return false;
}
void dfs_col(int v, int pr) {
  col[v] = 1;
  for (int e : a[0][v]) if (e != pr) {
    dfs_col(e, v);
  }
}
int main(){
  #ifdef home
  assert(freopen("a.out","wt",stdout));
  assert(freopen("a.in","rt",stdin));
  #endif              
  int n;
  scanf("%d", &n);
  for (int k = 0; k < 2; k++) {
    for (int i = 0; i < n - 1; i++) {
      int x, y;
      scanf("%d %d", &x, &y);
      x--, y--;
      add(k, x, y);
    }
  }  
  for (int k = 0; k < 2; k++) {
    for (int u = 0; u < n; u++) {
      for (int v : a[k][u]) if (u < v) {
        if (a[1 - k][u].find(v) == a[1 - k][u].end()) {
          s[k].insert(mp(u, v));
        }
      }
    }
  }
  printf("%d\n", sz(s[0]));
  while (sz(s[0]) > 0) {
    assert(sz(s[0]) == sz(s[1]));
    pair<int, int> e0 = *s[0].begin();
    st.clear();
    for (int i = 0; i < n; i++) {
      col[i] = 0;
    }
    dfs_col(e0.y, e0.x);    
    assert(dfs(e0.x, -1, e0.y));
    del(0, e0.x, e0.y);
    add(0, e1.x, e1.y);
    s[0].erase(e0);
    s[1].erase(e1);
    printf("%d %d %d %d\n", e0.x + 1, e0.y + 1, e1.x + 1, e1.y + 1);
  }
  return 0;
}
